// include
//--------------------------
#include <stdarg.h>
#include <stdio.h>
#include <assert.h>
#include "gui.h"
#include "share.h"
#include "../loader/resource.h"


// local globals
//--------------------------
static HWND    _hwnd = NULL;


// gui functions
//--------------------------
bool guiStart( HWND hwnd )
{
   assert(hwnd != NULL);
   _hwnd = hwnd;
   return true;
}

//--------------------------
bool guiStop( void )
{
   _hwnd = NULL;
   return true;
}

//--------------------------
bool guiPrint( const char* str, ... )
{
   va_list  args;
   int      index;
   char     message[BUF_STRING_SIZE];

   if(_hwnd == NULL)
      return false;

   va_start(args, str);
   vsprintf(message, str, args);
   va_end(args);

   index = SendDlgItemMessage(_hwnd, IDC_LIST, LB_ADDSTRING, (WPARAM)0, (LPARAM)(LPCTSTR)message);
   SendDlgItemMessage(_hwnd, IDC_LIST, LB_SETCURSEL, (WPARAM)index, (LPARAM)0);

   return true;
}
