/*
   loads and starts a dll in a remote process's memory space
*/

// include
//--------------------------
#include <windows.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>

#include "share.h"
#include "x86.h"
#include "gui.h"


// constants
//--------------------------
#define CFG_TARGET                        "tribes2.exe"
#define CFG_TARGET_PATH                   "GameData\\"CFG_TARGET

#define     PDU_MAXSIZE                   0x0300
#define     PDU_OFFSET_HMODULE            0x0000
#define     PDU_OFFSET_ISLOADED           0x0004
#define     PDU_OFFSET_LOADLIBRARY        0x0005
#define     PDU_OFFSET_FREELIBRARY        0x0009
#define     PDU_OFFSET_GETPROCADDRESS     0x000d
#define     PDU_OFFSET_HOOK_BACKUP        0x0011
#define     PDU_OFFSET_DLL_NAME           (PDU_OFFSET_HOOK_BACKUP+OP_BRANCH_SIZE)
#define     PDU_OFFSET_DLL_START          (PDU_OFFSET_DLL_NAME+BUF_PATH_SIZE)
#define     PDU_OFFSET_DLL_PDU            (PDU_OFFSET_DLL_START+BUF_WORD_SIZE)


// globals
//--------------------------
bool           g_is_patched =             false;
const char*    g_target_window_class =    "Darkstar Window Class";
const char*    g_target_window_pattern =  "Tribes 2";
const char*    g_target_module =          "tribes2.exe";
const char*    g_hack_dll =               "hm2.dll";
const char*    g_hack_dll_initfunction =  "hackStart";
unsigned int   g_patch_offset =           0x0400;
DWORD          g_base_address =           0x00400000;

HWND           g_target_hwnd =            NULL;
DWORD          g_process_id =             0;
HANDLE         g_process_handle =         NULL;
DWORD          g_thread_id =              0;
HMODULE        g_remote_library_handle =  NULL;


// types
//--------------------------
#pragma pack(1)
struct sPatchPDU
{
   HMODULE        remote_library_handle;
   bool           is_loaded;
   DWORD          fLoadLibrary;
   DWORD          fFreeLibrary;
   DWORD          fGetProcAddress;
   char           hook_backup[OP_BRANCH_SIZE];
   char           dll_name[BUF_PATH_SIZE];
   char           dll_start_function[BUF_WORD_SIZE];
   sInitPDU       dll_init_pdu;
};
#pragma pack()


// prototypes
//--------------------------
bool  loadTarget( void );
bool  loadPatch( void );
bool  unloadPatch( void );

bool  writeHook( HANDLE process_handle, DWORD hook_address, DWORD jump_address );
bool  writeMemory( HANDLE process_handle, void* address, void* data, DWORD data_size );
bool  readMemory( HANDLE process_handle, void* address, void* data, DWORD data_size );
bool  print( const char* str, ... );


// 1: start
//--------------------------
bool start( HINSTANCE instance )
{
   if( !loadTarget() )
      return false;
   if( !loadPatch() )
      return false;

   // TODO: find slicker way to do this
   while(guiState()==GUI_RUNNING)
   {
      DWORD    code;
      if(!GetExitCodeProcess(g_process_handle, &code))
         return false;
      if(code != STILL_ACTIVE)
      {
         Sleep(DELAY_LONG);
         g_is_patched = false;
         if( !loadTarget() )
            return false;
         if( !loadPatch() )
            return false;
      }
      Sleep(DELAY_LONG);
   }

   return true;
}


// 1: stop
//--------------------------
bool stop( void )
{
   if(g_is_patched && guiState()!=GUI_REMOTE_EXIT)
      unloadPatch();
   print("exiting");
   Sleep(DELAY_LONG);
   return true;
}


// 2: process loader
//--------------------------
bool loadTarget( void )
{
   print("waiting for: %s", (*g_target_window_pattern!='\0')?g_target_window_pattern:g_target_window_class);

   while(true)
   {
      if(guiState() != GUI_RUNNING)
         return false;
      g_target_hwnd = FindWindow(g_target_window_class, NULL);
      if(g_target_hwnd != NULL)
         break;
      Sleep(DELAY_SHORT);
   }
   char  found_name[BUF_STRING_SIZE];
   if(GetWindowText(g_target_hwnd, found_name, BUF_STRING_SIZE) <= 0)
      strcpy(found_name, g_target_window_class);
   print("found: %s", found_name);

   g_thread_id = GetWindowThreadProcessId(g_target_hwnd, &g_process_id);
	if( g_thread_id == 0)
   {
      print("error: could not determine process id");
      return false;
   }
   g_process_handle = OpenProcess(PROCESS_ALL_ACCESS, FALSE, g_process_id);
   if(g_process_handle == NULL)
   {
      print("error: could not open process");
      return false;
   }
   return true;
}


// 3: patch loader
//--------------------------
bool loadPatch( void )
{
   void        patchDllLoader(void);
   void        patchDllLoader_end(void);
   sPatchPDU   pdu;
   DWORD       base_address;
   DWORD       hook_address;
   DWORD       data_address;
   DWORD       code_address;

   // get addresses
   base_address = g_base_address;
   if(base_address == 0)
   {
      print("error: could not determine base address of %s", g_target_module);
      return false;
   }
   hook_address = GetClassLongA(g_target_hwnd, GCL_WNDPROC);
   if(hook_address == 0)
   {
      print("error: could not load WinProc address");
      return false;
   }
   data_address =   base_address + g_patch_offset;
   code_address =   data_address + PDU_MAXSIZE;

   // prepare pdu
   memset(&pdu, 0, sizeof sPatchPDU);
   // pdu.is_loaded
   pdu.is_loaded = false;
   // pdu.fLoadLibrary
   pdu.fLoadLibrary = (DWORD)LoadLibrary;
   // pdu.fFreeLibrary
   pdu.fFreeLibrary = (DWORD)FreeLibrary;
   // pdu.fGetProcAddress
   pdu.fGetProcAddress = (DWORD)GetProcAddress;
   // pdu.hook_backup
   if( !readMemory(g_process_handle, (void *)hook_address, pdu.hook_backup, OP_BRANCH_SIZE) )
      return false;
   // pdu.dll_init_pdu.path
	if(GetCurrentDirectory(BUF_PATH_SIZE, pdu.dll_init_pdu.path) == 0)
   {
      print("error: could not determine current directory");
      return false;
   }
   // pdu.dll_name
   sprintf(pdu.dll_name, "%s\\%s", pdu.dll_init_pdu.path, g_hack_dll);
   // pdu.dll_start_function
   strncpy(pdu.dll_start_function, g_hack_dll_initfunction, BUF_WORD_SIZE);
   pdu.dll_start_function[BUF_WORD_SIZE-1]= '\0';
   // pdu.dll_init_pdu
   pdu.dll_init_pdu.process_handle = g_process_handle;
   pdu.dll_init_pdu.process_id = g_process_id;
   pdu.dll_init_pdu.base_address = base_address;
   pdu.dll_init_pdu.hwnd = g_target_hwnd;
   pdu.dll_init_pdu.gui_hwnd = guiGetHwnd();
   pdu.dll_init_pdu.wndproc = (WNDPROC)hook_address;

   // patch data
   if( !writeMemory(g_process_handle, (void *)data_address, &pdu, sizeof sPatchPDU) )
      return false;

   // patch code
   DWORD code_size = (DWORD)patchDllLoader_end - (DWORD)patchDllLoader;
   if( !writeMemory(g_process_handle, (void *)code_address, patchDllLoader, code_size) )
      return false;

   // patch hook
   if( !writeHook(g_process_handle, hook_address, code_address) )
      return false;

   // wake up remote code
   SendMessage(g_target_hwnd, WM_NULL, 0, 0);
   Sleep(DELAY_MEDIUM);

   // check if loaded
   if( !readMemory(g_process_handle, (void *)data_address, &pdu, sizeof sPatchPDU) )
      return false;
   if(pdu.is_loaded != true)
   {
      print("error: failed to inject %s into %s", g_hack_dll, g_target_module);
      return false;
   }
   g_remote_library_handle = pdu.remote_library_handle;

   g_is_patched = true;
   return true;
}


// 3: patch unloader
//--------------------------
bool unloadPatch( void )
{
   void        patchDllUnLoader(void);
   void        patchDllUnLoader_end(void);
   sPatchPDU   pdu;
   DWORD       base_address;
   DWORD       hook_address;
   DWORD       data_address;
   DWORD       code_address;

   // get addresses
   base_address = g_base_address;
   hook_address = GetClassLongA(g_target_hwnd, GCL_WNDPROC);
   data_address = base_address + g_patch_offset;
   code_address = data_address + PDU_MAXSIZE;

   // patch code
   DWORD code_size = (DWORD)patchDllUnLoader_end - (DWORD)patchDllUnLoader;
   if( !writeMemory(g_process_handle, (void *)code_address, patchDllUnLoader, code_size) )
      return false;

   // patch hook
   if( !writeHook(g_process_handle, hook_address, code_address) )
      return false;

   // wake up remote code
   SendMessage(g_target_hwnd, WM_NULL, 0, 0);

   // check if unloaded
   if( !readMemory(g_process_handle, (void *)data_address, &pdu, sizeof sPatchPDU) )
      return false;
   if(pdu.is_loaded != false)
   {
      print("error: failed to unload %s from %s", g_hack_dll, g_target_module);
      return false;
   }
   g_is_patched = false;
   return true;
}


// utilities
//--------------------------
static bool writeHook( HANDLE process_handle, DWORD hook_address, DWORD jump_address )
{
   unsigned char  hook_data[OP_BRANCH_SIZE];

   hook_data[0] = OP_CALL;     // call
   *(int *)&hook_data[1] = (jump_address - hook_address) - OP_BRANCH_SIZE;

   if( !writeMemory(process_handle, (void *)hook_address, hook_data, OP_BRANCH_SIZE) )
      return false;

   return true;
}


//--------------------------
static bool writeMemory( HANDLE process_handle, void* address, void* data, DWORD data_size )
{
   DWORD       old_permissions;

   if( !VirtualProtectEx(process_handle, address, data_size, PAGE_EXECUTE_READWRITE, &old_permissions) )
   {
      print("error: could not change permissions on page at %x", address);
      return false;
   }
   if( !WriteProcessMemory(process_handle, address, data, data_size, NULL) )
   {
      print("error: could not write to %x", address);
      return false;
   }
   return true;
}


//--------------------------
static bool readMemory( HANDLE process_handle, void* address, void* data, DWORD data_size )
{
   if( !ReadProcessMemory(process_handle, address, data, data_size, NULL) )
   {
      print("error: failed to read %d bytes at %x", data_size, address);
      return false;
   }
   return true;
}


//--------------------------
static bool print( const char* str, ... )
{
   va_list  args;
   char     message[BUF_STRING_SIZE];

   va_start(args, str);
   vsprintf(message, str, args);
   va_end(args);

   guiPrint(message);

   return true;
}


// dll loader routine
//--------------------------
void _declspec(naked) patchDllLoader(void)
{
	__asm
   {
      push  esi;
      call  get_data_address;                         // grab eip
get_data_address:
      pop   esi;
      sub   esi, 0x6;                                 // base address of this call
      sub   esi, PDU_MAXSIZE;                         // esi = address of data
// restart eip before this call
      push  ebx;
      mov   ebx, [esp+0x8];
      sub   ebx, OP_BRANCH_SIZE;                      // get hook eip
      mov   [esp+0x8], ebx;                           // reset return eip to start of hook
// rewrite backup hook data
		pushad;
      mov   eax, 0;
      lea   ecx, [esi + PDU_OFFSET_HOOK_BACKUP];      // ecx = hook backup address
backup_loop:
      mov   dl, byte ptr [ecx+eax];                   // read backup hook data
      mov   byte ptr [ebx+eax], dl;                   // restore original hook data
      inc   eax;
      cmp   eax, OP_BRANCH_SIZE;
      jne   backup_loop;
// load dll
      mov   eax, [esi + PDU_OFFSET_LOADLIBRARY];      // eax = LoadLibrary address
      lea   ebx, [esi + PDU_OFFSET_DLL_NAME];         // ebx = dll name address
      push  ebx;
      call  eax;                                      // LoadLibrary()
      cmp   eax, 0;
      je    end;
// get dll init routine
      mov   ecx, [esi + PDU_OFFSET_GETPROCADDRESS];   // eax = GetProcAddress address
      lea   ebx, [esi + PDU_OFFSET_DLL_START];         
      mov   [esi + PDU_OFFSET_HMODULE], eax;          // save hmodule
      push  ebx;                                      // param 2: dll start function name
      push  eax;                                      // param 1: hmodule
      call  ecx;                                      // GetProcAddress()
      cmp   eax, 0;
      je    fail;
// call dll init routine
      lea   ebx, [esi + PDU_OFFSET_DLL_PDU];          // ebx = dll init pdu
      push  ebx;
      call  eax;
      cmp   eax, 0;
      je    fail;
      mov   byte ptr [esi + PDU_OFFSET_ISLOADED], 1;  // set is loaded state
      jmp   end;
fail:
// free library
      mov   eax, [esi + PDU_OFFSET_FREELIBRARY];      // eax = FreeLibrary address
      mov   ebx, [esi + PDU_OFFSET_HMODULE];          // get hmodule
      push  ebx;                                      // param 1: hmodule
      call  eax;                                      // LoadLibrary()
end:
      popad;
      pop   ebx;
      pop   esi;
      ret;
   };
}
void _declspec(naked) patchDllLoader_end(void){}



// dll unloader routine
//--------------------------
void _declspec(naked) patchDllUnLoader(void)
{
	__asm
   {
      push  esi;
      call  get_data_address;                         // grab eip
get_data_address:
      pop   esi;
      sub   esi, 0x6;                                 // base address of this call
      sub   esi, PDU_MAXSIZE;                         // esi = address of data
// restart eip before this call
      push  ebx;
      mov   ebx, [esp+0x8];
      sub   ebx, OP_BRANCH_SIZE;                      // get hook eip
      mov   [esp+0x8], ebx;                           // reset return eip to start of hook
// rewrite backup hook data
		pushad;
      mov   eax, 0;
      lea   ecx, [esi + PDU_OFFSET_HOOK_BACKUP];      // ecx = hook backup address
backup_loop:
      mov   dl, byte ptr [ecx+eax];                   // read backup hook data
      mov   byte ptr [ebx+eax], dl;                   // restore original hook data
      inc   eax;
      cmp   eax, OP_BRANCH_SIZE;
      jne   backup_loop;
// free library
      mov   eax, [esi + PDU_OFFSET_FREELIBRARY];      // eax = FreeLibrary address
      mov   ebx, [esi + PDU_OFFSET_HMODULE];          // get hmodule
      push  ebx;                                      // param 1: hmodule
      call  eax;                                      // LoadLibrary()
      cmp   eax, 0;
      je    end;
      mov   byte ptr [esi + PDU_OFFSET_ISLOADED], 0;  // set is not loaded state
end:
      popad;
      pop   ebx;
      pop   esi;
      ret;
   };
}
void _declspec(naked) patchDllUnLoader_end(void){}
