// include
//--------------------------
#include <stdio.h>
#include <assert.h>
#include <stdarg.h>
#include "share.h"
#include "Log.h"


// Log
//--------------------------
Log::Log( void )
{
   _file_name = NULL;
   _handle = NULL;
}

bool Log::open( void )
{
   assert(_file_name != NULL);
   _handle = fopen(_file_name, "a");
   if(!_handle)
      return false;
   return true;
}

void Log::close( void )
{
   if(_handle != NULL)
      fclose(_handle);
   _handle = NULL;
}

void Log::print( const char *string, ... )
{
   va_list  args;

   assert(string != NULL);
   assert(_handle);

   va_start(args, string);
   vfprintf(_handle, string, args);
   va_end(args);
   fflush(_handle);
}
