#ifndef _M_H_
#define _M_H_

// defs
//----------------------------------------------------
#define  PID2           1.570796327f
#define  PI             3.141592654f
#define  PI2            6.283185307f
#define  RAD2DEG(rad)   ((rad)*360.0f/PI2)
#define  ISNAN(f) ( ((*(int*)&f)&0x7F800000)==0x7F800000 || ((*(int*)&f)&0x7F800000)==0x00000000 )


// macros
//----------------------------------------------------
#define RANGE_TO(v,l)   ((v)>(l))?((v)=(l)):(((v)<-(l))?((v)=-(l)):0)


// types
//----------------------------------------------------
typedef struct
{
   float    x;
   float    y;
} sVertex2f;

typedef struct
{
   float    x;
   float    y;
   float    z;
} sVertex3f;


// math functions
//----------------------------------------------------
float vecMagnitude2( const sVertex2f& in_vector );
float vecMagnitude3( const sVertex3f& in_vector );
float vecAngle2( const sVertex2f& in_v1, const sVertex2f& in_v2 );
void  vecSubtract2( sVertex2f& out_v, const sVertex2f& in_v1, const sVertex2f& in_v2 );
void  vecSubtract3( sVertex3f& out_v, const sVertex3f& in_v1, const sVertex3f& in_v2 );
float vecDirCos3( sVertex3f& out_a, const sVertex3f& v );


#endif //_M_H_
