#pragma once

// include
//--------------------------
#include <windows.h>
#include "Log.h"


// macros
//--------------------------
#define PAD_PREFIX()                p
#define PAD(size)                   char PAD_PREFIX()__LINE__[(size)];
#define ARRAY_SIZE(a)               (sizeof(a)/sizeof(a[0]))


// buffer sizes
//--------------------------
#define BUF_WORD_SIZE               32
#define BUF_STRING_SIZE             256
#define BUF_FILENAME_SIZE           64
#define BUF_LINE_SIZE               512
#define BUF_PATH_SIZE               256
#define BUF_MAX_PLUGINS             256

#define DELAY_SHORT                 10
#define DELAY_MEDIUM                100
#define DELAY_LONG                  1000



// types
//--------------------------
struct sInitPDU
{
   HANDLE      process_handle;
   DWORD       process_id;
   DWORD       base_address;
   HWND        hwnd;
   HWND        gui_hwnd;
   WNDPROC     wndproc;
   char        path[BUF_PATH_SIZE];
};


// globals
//--------------------------
bool print( const char* str, ... );
void scriptMessage( const char* message, ... );
void scriptEcho( const char* message, ... );

extern sInitPDU   g_init_pdu;
extern Log        g_log;
